#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
// #include <util/delay.h>


#include "hal_smb380.h"
#include "hal_mlx90609.h"
#include "uart.h"


/* define CPU frequency in MHz here if not defined in Makefile */
#ifndef F_CPU
#define F_CPU 18432000UL
#endif

/* define the baudrate */
#define UART_BAUD_RATE 115200      


/*============================ IMPLEMENTATION ================================*/

/*----------------------------------------------------------------------------*/
/** \brief  This function is the main program.
 *
 */
int main( void){

	unsigned char c;
	unsigned char sampleData=0;
	unsigned char acc_x_new=0;
	unsigned char acc_y_new=0;
	unsigned char acc_z_new=0;
	unsigned char angular_x_new=0;
	unsigned char angular_y_new=0;
	unsigned char angular_z_new=0;

	int16_t acc_x=0;
	int16_t acc_y=0;
	int16_t acc_z=0;

	uint16_t angular_x=0;
	uint16_t angular_y=0;
	uint16_t angular_z=0;

	char buffer_acc_x[7];
	char buffer_acc_y[7];
	char buffer_acc_z[7];

	char buffer_angular_x[7];
	char buffer_angular_y[7];
	char buffer_angular_z[7];


	hal_smb380_init();
	hal_mlx90609_init();


	while( !hal_mlx90609_enable_active_mode(CS1)){
	};

	while( !hal_mlx90609_enable_active_mode(CS2)){
	};

	while( !hal_mlx90609_enable_active_mode(CS3)){
	};

    /*
     *  Initialize UART library, pass baudrate and AVR cpu clock
     *  with the macro 
     *  UART_BAUD_SELECT() (normal speed mode )
     *  or 
     *  UART_BAUD_SELECT_DOUBLE_SPEED() ( double speed mode)
     */
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) ); 

    /*
     * now enable interrupt, since UART library is interrupt controlled
     */
	sei();



	while(1){
		
		c = uart_getc();

		if( (unsigned char)c == 't' )
      		sampleData = 1;

    		if( (unsigned char)c == 's' )
      		sampleData = 0;

    		if( sampleData ) {

      		if( hal_smb380_new_acc_read( 0x02, &acc_x )) {
				acc_x_new=1;
			}
      		if( hal_smb380_new_acc_read( 0x04, &acc_y )) {
				acc_y_new=1;
			}
     			if( hal_smb380_new_acc_read( 0x06, &acc_z )) {
				acc_z_new=1;
			}
/*			if( hal_mlx90609_read_conversion_result( CS1, &angular_x)){
				angular_x_new=1;
			}
			if( hal_mlx90609_read_conversion_result( CS2, &angular_y)){
				angular_y_new=1;
			}
			if( hal_mlx90609_read_conversion_result( CS3, &angular_z)){
				angular_z_new=1;
			}
*/
			if( acc_x_new && acc_y_new && acc_z_new /*&& angular_x_new && angular_y_new && angular_z_new*/) {

        			itoa( acc_x, buffer_acc_x, 10 );   // convert interger into string (decimal format)         
				itoa( acc_y, buffer_acc_y, 10 );   // convert interger into string (decimal format)         
				itoa( acc_z, buffer_acc_z, 10 );   // convert interger into string (decimal format)         
        		
				uart_puts( "acc , " );
        			uart_puts( buffer_acc_x );        // and transmit string to UART
				uart_puts( " , " );
				uart_puts( buffer_acc_y );        // and transmit string to UART
				uart_puts( " , " );
				uart_puts( buffer_acc_z );        // and transmit string to UART
        			uart_puts( "\r\n" );

				acc_x_new=0;
				acc_y_new=0;
				acc_z_new=0;

				acc_x=0;
				acc_y=0;
				acc_z=0;
      	
/*
				itoa( angular_x, buffer_angular_x, 10);   // convert interger into string (decimal format)         
				itoa( angular_y, buffer_angular_y, 10);   // convert interger into string (decimal format)         
				itoa( angular_z, buffer_angular_z, 10);   // convert interger into string (decimal format)         

				uart_puts( "ang , " );
				uart_puts( buffer_angular_x );        // and transmit string to UART
				uart_puts( " , " );
				uart_puts( buffer_angular_y );        // and transmit string to UART
				uart_puts( " , " );
				uart_puts( buffer_angular_z );        // and transmit string to UART
        			uart_puts( "\r\n" );

				angular_x_new = 0;
				angular_y_new = 0;
				angular_z_new = 0;

				angular_x = 0;
				angular_y = 0;
				angular_z = 0;

				hal_mlx90609_start_angular_conversion( CS1);
				hal_mlx90609_start_angular_conversion( CS2);
				hal_mlx90609_start_angular_conversion( CS3);
*/
			}
    		}
  	}

	return 0;
}
